'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var reactAdvancedCropper = require('react-advanced-cropper');
var tslib = require('tslib');
var React = require('react');
var cn = require('classnames');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var cn__default = /*#__PURE__*/_interopDefaultLegacy(cn);

var FlipHorizontalIcon = function (_a) {
    var className = _a.className;
    return (React__default["default"].createElement("svg", { className: className, xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16" },
        React__default["default"].createElement("path", { fill: "#FFF", d: "M8 15.9c-.6 0-1-.4-1-1V1c0-.6.4-1 1-1s1 .4 1 1v13.9c0 .6-.4 1-1 1zm4-2.4h-.5c-.4 0-.8-.3-.8-.8s.3-.8.8-.8h.5c.4 0 .8.3.8.8s-.4.8-.8.8zm2.7 0h-.5c-.4 0-.8-.3-.8-.8 0-.3.2-.6.5-.7.1-.3.4-.5.7-.5.4 0 .8.3.8.8v.5c.1.4-.3.7-.7.7zm0-2.8c-.4 0-.8-.3-.8-.8v-.8c0-.4.3-.8.8-.8s.8.3.8.8v.8c0 .4-.4.8-.8.8zm0-3.3c-.4 0-.8-.3-.8-.8v-.7c0-.4.3-.8.8-.8s.8.3.8.8v.8c0 .4-.4.7-.8.7zm0-3.3c-.3 0-.6-.2-.7-.5-.3-.1-.5-.4-.5-.7 0-.4.3-.8.8-.8h.5c.4 0 .8.3.8.8v.5c-.1.4-.5.7-.9.7zM12 3.6h-.5c-.4 0-.8-.3-.8-.8s.3-.8.8-.8h.5c.4 0 .8.3.8.8s-.4.8-.8.8zM4.5 13.5H1.3c-.4 0-.8-.3-.8-.8V2.9c0-.4.3-.8.8-.8h3.2v1.5H2V12h2.5v1.5z" })));
};

var RotateRightIcon = function (_a) {
    var className = _a.className;
    return (React__default["default"].createElement("svg", { className: className, xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16" },
        React__default["default"].createElement("path", { fill: "#FFF", d: "M12.5 11.8c.2.2.2.6 0 .9-1.1 1.1-2.8 1.8-4.5 1.8-3.7 0-6.5-2.8-6.5-6.5s3-6.5 6.5-6.5c1.7 0 3.3.7 4.5 1.8l1-1c.4-.4 1-.1 1 .4v3.8c0 .3-.3.6-.6.6h-3.7c-.5 0-.8-.7-.4-1L11 4.9c-.9-.9-1.9-1.3-3-1.3-3 0-5.4 3.1-4 6.2.7 1.6 2.3 2.6 4 2.6 1.2 0 2.2-.4 3-1.3.2-.2.6-.2.8 0l.7.7z" })));
};

var RotateLeftIcon = function (_a) {
    var className = _a.className;
    return (React__default["default"].createElement("svg", { className: className, xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16" },
        React__default["default"].createElement("path", { fill: "#FFF", d: "M3.5 11.8c-.2.2-.2.6 0 .9 1.1 1.1 2.8 1.8 4.5 1.8 3.7 0 6.5-2.8 6.5-6.5s-3-6.5-6.5-6.5c-1.7 0-3.3.7-4.5 1.8l-1-1c-.4-.4-1-.1-1 .4v3.8c0 .3.3.6.6.6h3.7c.5 0 .8-.7.4-1L5 4.9c.9-.9 1.9-1.3 3-1.3 3 0 5.4 3.1 4 6.2-.7 1.6-2.3 2.6-4 2.6-1.2 0-2.2-.4-3-1.3-.2-.2-.6-.2-.8 0l-.7.7z" })));
};

var FlipVerticalIcon = function (_a) {
    var className = _a.className;
    return (React__default["default"].createElement("svg", { className: className, xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16" },
        React__default["default"].createElement("path", { fill: "#FFF", d: "M15 9H1c-.5 0-1-.5-1-1s.4-1 1-1h14c.6 0 1 .4 1 1s-.5 1-1 1zM3.1 12.7c-.4 0-.8-.3-.8-.8v-.5c0-.4.3-.8.8-.8s.8.3.8.8v.6c0 .4-.3.7-.8.7zM3.6 15.4h-.5c-.4 0-.8-.3-.8-.8v-.5c0-.4.3-.8.8-.8.3 0 .6.2.7.5.3.1.5.4.5.7.1.6-.2.9-.7.9zM10.1 15.4h-.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8h.8c.4 0 .8.3.8.8s-.4.8-.8.8zm-3.2 0H6c-.4 0-.8-.3-.8-.8s.3-.8.8-.8h.8c.4 0 .8.3.8.8s-.3.8-.7.8zM13 15.4h-.5c-.4 0-.8-.3-.8-.8 0-.3.2-.6.5-.7.1-.3.4-.5.7-.5.4 0 .8.3.8.8v.5c.1.4-.2.7-.7.7zM13 12.7c-.4 0-.8-.3-.8-.8v-.5c0-.4.3-.8.8-.8s.8.3.8.8v.6c0 .4-.3.7-.8.7z" }),
        React__default["default"].createElement("g", null,
            React__default["default"].createElement("path", { fill: "#FFF", d: "M13.8 4.5h-1.5V2H3.9v2.5H2.4V1.3c0-.4.3-.8.8-.8H13c.4 0 .8.3.8.8v3.2z" }))));
};

function range(from, to, step) {
    if (step === void 0) { step = 1; }
    var index = -1;
    var length = Math.max(Math.ceil((to - from) / (step || 1)), 0);
    var result = new Array(length);
    while (length--) {
        result[++index] = from;
        from += step;
    }
    return result;
}
var RotateComponent = React.forwardRef(function (_a, ref) {
    var from = _a.from, to = _a.to, value = _a.value, _b = _a.step, step = _b === void 0 ? 2.5 : _b, _c = _a.thickness, thickness = _c === void 0 ? 2 : _c, onBlur = _a.onBlur, onChange = _a.onChange, className = _a.className, valueBarClassName = _a.valueBarClassName, barsClassName = _a.barsClassName, barClassName = _a.barClassName, highlightedBarClassName = _a.highlightedBarClassName, zeroBarClassName = _a.zeroBarClassName, _d = _a.density, density = _d === void 0 ? 10 : _d;
    var barsRef = React.useRef(null);
    var _e = tslib.__read(React.useState(false), 2), dragging = _e[0], setDragging = _e[1];
    var _f = tslib.__read(React.useState([]), 2), items = _f[0], setItems = _f[1];
    var recalculate = function () {
        if (barsRef.current) {
            var width_1 = barsRef.current.clientWidth;
            var count_1 = width_1 / density;
            var neededLeftBarsCount = Math.max(0, Math.floor(count_1 / 2) - Math.round((value - from) / step));
            var neededRightBarsCount = Math.max(0, Math.floor(count_1 / 2) - Math.round((to - value) / step));
            var values = tslib.__spreadArray(tslib.__spreadArray(tslib.__spreadArray([], tslib.__read(range(from - neededLeftBarsCount * step, from, step)), false), tslib.__read(range(from, to + step, step)), false), tslib.__read(range(to + step, to + step + neededRightBarsCount * step, step)), false);
            var radius_1 = Math.abs(Math.ceil(count_1 / 2) * step);
            setItems(values.map(function (barValue) {
                var sign = Math.sign(barValue - value);
                // Opacity
                var translate;
                if (Math.abs(barValue - value) / step <= Math.ceil(count_1 / 2)) {
                    var multiplier = Math.sqrt(Math.pow(radius_1, 2) - Math.pow(value + sign * radius_1 - barValue, 2)) / radius_1;
                    translate = width_1 / 2 + sign * (width_1 / 2) * Math.pow(multiplier, 2.5);
                }
                else {
                    translate = width_1 / 2 + (sign * width_1) / 2;
                }
                // Translate
                var opacity = 0;
                if (count_1 > 0 && Math.abs(barValue - value) / step <= Math.ceil(count_1 / 2)) {
                    opacity = Math.pow(Math.sqrt(Math.pow(radius_1, 2) - Math.pow(value - barValue, 2)) / radius_1, 4);
                }
                return {
                    value: barValue,
                    highlighted: (value < 0 && barValue >= value && barValue <= 0) ||
                        (value > 0 && barValue <= value && barValue >= 0),
                    zero: barValue === 0,
                    opacity: opacity,
                    translate: translate - thickness / 2,
                };
            }));
        }
    };
    React.useEffect(function () {
        recalculate();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [density, thickness, from, to, value, step]);
    React.useImperativeHandle(ref, function () {
        return {
            refresh: recalculate,
        };
    });
    var onMove = function (directions) {
        if (barsRef.current) {
            var width = barsRef.current.clientWidth;
            var count = width / density;
            var shift = -(directions.left / barsRef.current.clientWidth) * count * step;
            if (onChange) {
                if (value + shift > to) {
                    onChange(to - value);
                }
                else if (value + shift < from) {
                    onChange(from - value);
                }
                else {
                    onChange(shift);
                }
            }
        }
    };
    var onMoveEnd = function () {
        document.body.classList.remove('dragging');
        setDragging(false);
        onBlur === null || onBlur === void 0 ? void 0 : onBlur();
    };
    var onMoveStart = function () {
        document.body.classList.add('dragging');
        setDragging(true);
    };
    return (React__default["default"].createElement("div", { className: cn__default["default"]('rmc-rotate-component', className) },
        React__default["default"].createElement(reactAdvancedCropper.DraggableArea, { onMoveStart: onMoveStart, onMove: onMove, onMoveEnd: onMoveEnd, useAnchor: false },
            React__default["default"].createElement("div", { className: cn__default["default"]('rmc-rotate-component__bars', dragging && 'rmc-rotate-component__bars--dragging', barsClassName), ref: barsRef },
                items.map(function (bar) { return (React__default["default"].createElement("div", { className: cn__default["default"]('rmc-rotate-component__bar', bar.zero && 'rmc-rotate-component__bar--zero', bar.highlighted && 'rmc-rotate-component__bar--highlighted', barClassName, bar.highlighted && highlightedBarClassName, bar.zero && zeroBarClassName), key: bar.value, style: {
                        width: bar.opacity ? thickness : 0,
                        opacity: bar.opacity,
                        transform: "translate(" + bar.translate + "px, -50%)",
                    } })); }),
                React__default["default"].createElement("div", { className: cn__default["default"]('rmc-rotate-component__value', valueBarClassName) },
                    React__default["default"].createElement("div", { className: "rmc-rotate-component__value-number" },
                        value.toFixed(1),
                        "\u00B0"))))));
});
RotateComponent.displayName = 'RotateComponent';

var Navigation = React.forwardRef(function (_a, ref) {
    var className = _a.className, buttonClassName = _a.buttonClassName, rotateComponentClassName = _a.rotateComponentClassName, barClassName = _a.barClassName, highlightedBarClassName = _a.highlightedBarClassName, zeroBarClassName = _a.zeroBarClassName, valueBarClassName = _a.valueBarClassName, disabled = _a.disabled, value = _a.value, onRotate = _a.onRotate, onRotateEnd = _a.onRotateEnd, onFlip = _a.onFlip;
    var _b = tslib.__read(React.useState(0), 2), quarter = _b[0], setQuarter = _b[1];
    var _c = tslib.__read(React.useState(0), 2), adjustmentAngle = _c[0], setAdjustmentAngle = _c[1];
    var rotateComponentRef = React.useRef(null);
    React.useLayoutEffect(function () {
        var absRotate = Math.abs(value);
        var rotate;
        if (absRotate % 90 > 45) {
            rotate = (absRotate - (absRotate % 90) + 90) / 90;
        }
        else if (absRotate % 90 < 45) {
            rotate = (absRotate - (absRotate % 90)) / 90;
        }
        else {
            rotate = quarter;
        }
        rotate = Math.sign(rotate) * rotate;
        if (rotate !== quarter) {
            setQuarter(rotate);
        }
        setAdjustmentAngle(Math.sign(value) * (Math.abs(value) - Math.abs(rotate) * 90));
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [value]);
    React.useImperativeHandle(ref, function () {
        return {
            refresh: function () {
                if (rotateComponentRef.current) {
                    rotateComponentRef.current.refresh();
                }
            },
        };
    });
    var rotateTo = function (angle) {
        if (onRotate && !disabled) {
            onRotate(angle, {
                transitions: false,
                interaction: true,
                immediately: true,
            });
        }
    };
    var rotateLeft = function () {
        if (onRotate && !disabled) {
            if (adjustmentAngle > 0) {
                onRotate(-adjustmentAngle);
            }
            else if (adjustmentAngle < 0) {
                onRotate(-90 - adjustmentAngle);
            }
            else {
                onRotate(-90);
            }
        }
    };
    var rotateRight = function () {
        if (onRotate && !disabled) {
            if (adjustmentAngle > 0) {
                onRotate(90 - adjustmentAngle);
            }
            else if (adjustmentAngle < 0) {
                onRotate(-adjustmentAngle);
            }
            else {
                onRotate(90);
            }
        }
    };
    var flipHorizontal = function () {
        if (onFlip && !disabled) {
            onFlip(true);
        }
    };
    var flipVertical = function () {
        if (onFlip && !disabled) {
            onFlip(false, true);
        }
    };
    return (React__default["default"].createElement("div", { className: cn__default["default"]('rmc-navigation', className) },
        React__default["default"].createElement("button", { className: cn__default["default"]('rmc-navigation__button', buttonClassName), onClick: flipHorizontal },
            React__default["default"].createElement(FlipHorizontalIcon, null)),
        React__default["default"].createElement("button", { className: cn__default["default"]('rmc-navigation__button', buttonClassName), onClick: rotateRight },
            React__default["default"].createElement(RotateRightIcon, null)),
        React__default["default"].createElement(RotateComponent, { ref: rotateComponentRef, className: cn__default["default"]('rmc-navigation__rotator', rotateComponentClassName), barClassName: barClassName, zeroBarClassName: zeroBarClassName, valueBarClassName: valueBarClassName, highlightedBarClassName: highlightedBarClassName, onChange: rotateTo, onBlur: onRotateEnd, from: -45, to: 45, value: adjustmentAngle }),
        React__default["default"].createElement("button", { className: cn__default["default"]('rmc-navigation__button', buttonClassName), onClick: rotateLeft },
            React__default["default"].createElement(RotateLeftIcon, null)),
        React__default["default"].createElement("button", { className: cn__default["default"]('rmc-navigation__button', buttonClassName), onClick: flipVertical },
            React__default["default"].createElement(FlipVerticalIcon, null))));
});
Navigation.displayName = 'Navigation';

function isFunction(value) {
    return typeof value === 'function';
}
function isUndefined(obj) {
    return obj === undefined;
}
var isObject = function (term) {
    return term !== null && typeof term === 'object';
};
function parseNumber(number) {
    var parsedNumber = Number(number);
    if (Number.isNaN(parsedNumber)) {
        return number;
    }
    else {
        return parsedNumber;
    }
}
function isNumber(value) {
    return typeof value === 'number';
}
function isString(value) {
    return typeof value === 'string';
}
function isNaN(value) {
    return value !== value;
}
function isNumeric(value) {
    return ((isNumber(value) && !isNaN(value)) ||
        (isString(value) && !Number.isNaN(parseFloat(value)) && isFinite(parseFloat(value))));
}
function isRoughlyEqual(a, b, tolerance) {
    if (tolerance === void 0) { tolerance = 1e-3; }
    return Math.abs(b - a) < tolerance;
}
function isGreater(a, b, tolerance) {
    return isRoughlyEqual(a, b, tolerance) ? false : a > b;
}
function isLower(a, b, tolerance) {
    return isRoughlyEqual(a, b, tolerance) ? false : a < b;
}
// Not performant, small function to reduce the code amount
function deepClone(obj) {
    if (!isObject(obj)) {
        return obj;
    }
    var result = {};
    if (Array.isArray(obj)) {
        result = obj.map(function (item) { return deepClone(item); });
    }
    else {
        Object.keys(obj).forEach(function (key) {
            return (result[key] = deepClone(obj[key]));
        });
    }
    return result;
}
function deepCompare(a, b, tolerance) {
    if (tolerance === void 0) { tolerance = 1e-3; }
    if (isNumber(a) && isNumber(b) && isRoughlyEqual(a, b, tolerance))
        return true;
    if (a === b)
        return true;
    if (a && b && typeof a == 'object' && typeof b == 'object') {
        if (a.constructor !== b.constructor)
            return false;
        var length_1, i = void 0;
        if (Array.isArray(a)) {
            length_1 = a.length;
            if (length_1 != b.length)
                return false;
            for (i = length_1; i-- !== 0;)
                if (!deepCompare(a[i], b[i], tolerance))
                    return false;
            return true;
        }
        if (a.valueOf !== Object.prototype.valueOf)
            return a.valueOf() === b.valueOf();
        if (a.toString !== Object.prototype.toString)
            return a.toString() === b.toString();
        var keys = Object.keys(a);
        length_1 = keys.length;
        if (length_1 !== Object.keys(b).length)
            return false;
        for (i = length_1; i-- !== 0;)
            if (!Object.prototype.hasOwnProperty.call(b, keys[i]))
                return false;
        for (i = length_1; i-- !== 0;) {
            var key = keys[i];
            if (!deepCompare(a[key], b[key], tolerance))
                return false;
        }
        return true;
    }
    return a !== a && b !== b;
}

var ALL_DIRECTIONS = ['left', 'right', 'top', 'bottom'];
var HORIZONTAL_DIRECTIONS = ['left', 'right'];
var VERTICAL_DIRECTIONS = ['top', 'bottom'];

function diff(firstObject, secondObject) {
    return {
        left: firstObject.left - secondObject.left,
        top: firstObject.top - secondObject.top,
    };
}
function getCenter(object) {
    return {
        left: object.left + object.width / 2,
        top: object.top + object.height / 2,
    };
}
function sizeDistance(a, b) {
    return Math.pow(a.width - b.width, 2) + Math.pow(a.height - b.height, 2);
}
function applyDirections(coordinates, directions) {
    return {
        left: coordinates.left - directions.left,
        top: coordinates.top - directions.top,
        width: coordinates.width + directions.left + directions.right,
        height: coordinates.height + directions.top + directions.bottom,
    };
}
function inverseMove(directions) {
    return {
        left: -directions.left,
        top: -directions.top,
    };
}
function applyMove(object, move) {
    return tslib.__assign(tslib.__assign({}, object), { left: object.left + move.left, top: object.top + move.top });
}
function coordinatesToPositionRestrictions(coordinates) {
    return {
        left: coordinates.left,
        top: coordinates.top,
        right: coordinates.left + coordinates.width,
        bottom: coordinates.top + coordinates.height,
    };
}
function applyScale(object, factor, center, progress) {
    if (factor !== 1) {
        if ('left' in object || 'top' in object) {
            if (center) {
                var currentCenter = getCenter(object);
                return {
                    width: object.width * factor,
                    height: object.height * factor,
                    left: object.left +
                        (object.width * (1 - factor)) / 2 +
                        (center.left - currentCenter.left) * (progress || 1 - factor),
                    top: object.top +
                        (object.height * (1 - factor)) / 2 +
                        (center.top - currentCenter.top) * (progress || 1 - factor),
                };
            }
            else {
                return {
                    width: object.width * factor,
                    height: object.height * factor,
                    left: object.left + (object.width * (1 - factor)) / 2,
                    top: object.top + (object.height * (1 - factor)) / 2,
                };
            }
        }
        else {
            return {
                width: object.width * factor,
                height: object.height * factor,
            };
        }
    }
    else {
        return object;
    }
}
function ratio(object) {
    return object.width / object.height;
}
function maxScale(size, restrictions) {
    return Math.min(restrictions.maxWidth ? restrictions.maxWidth / size.width : Infinity, restrictions.maxHeight ? restrictions.maxHeight / size.height : Infinity);
}
function minScale(size, restrictions) {
    return Math.max(restrictions.minWidth ? restrictions.minWidth / size.width : 0, restrictions.minHeight ? restrictions.minHeight / size.height : 0);
}
function getBrokenRatio(currentAspectRatio, aspectRatio) {
    var ratioBroken;
    if (aspectRatio.minimum && isLower(currentAspectRatio, aspectRatio.minimum)) {
        ratioBroken = aspectRatio.minimum;
    }
    else if (aspectRatio.maximum && isGreater(currentAspectRatio, aspectRatio.maximum)) {
        ratioBroken = aspectRatio.maximum;
    }
    return ratioBroken;
}
function fitToSizeRestrictions(coordinates, sizeRestrictions) {
    var aspectRatio = ratio(coordinates);
    var scale = 1;
    if (sizeRestrictions.minWidth > 0 && sizeRestrictions.minHeight > 0) {
        if (aspectRatio > sizeRestrictions.minWidth / sizeRestrictions.minHeight) {
            if (coordinates.height < sizeRestrictions.minHeight) {
                scale = sizeRestrictions.minHeight / coordinates.height;
            }
        }
        else {
            if (coordinates.width < sizeRestrictions.minWidth) {
                scale = sizeRestrictions.minWidth / coordinates.width;
            }
        }
    }
    else if (sizeRestrictions.minWidth > 0) {
        if (coordinates.width < sizeRestrictions.minWidth) {
            scale = sizeRestrictions.minWidth / coordinates.width;
        }
    }
    else if (sizeRestrictions.minHeight > 0) {
        if (coordinates.height < sizeRestrictions.minHeight) {
            scale = sizeRestrictions.minHeight / coordinates.height;
        }
    }
    if (sizeRestrictions.maxWidth < Infinity && sizeRestrictions.maxHeight < Infinity) {
        if (aspectRatio > sizeRestrictions.maxWidth / sizeRestrictions.maxHeight) {
            if (coordinates.width > sizeRestrictions.maxWidth) {
                scale = sizeRestrictions.maxWidth / coordinates.width;
            }
        }
        else {
            if (coordinates.height > sizeRestrictions.maxHeight) {
                scale = sizeRestrictions.maxHeight / coordinates.height;
            }
        }
    }
    else if (sizeRestrictions.maxWidth < Infinity) {
        if (coordinates.width > sizeRestrictions.maxWidth) {
            scale = sizeRestrictions.maxWidth / coordinates.width;
        }
    }
    else if (sizeRestrictions.maxHeight < Infinity) {
        if (coordinates.height > sizeRestrictions.maxHeight) {
            scale = sizeRestrictions.maxHeight / coordinates.height;
        }
    }
    return scale;
}
function getIntersections(object, positionRestrictions) {
    var intersections = {
        left: 0,
        top: 0,
        right: 0,
        bottom: 0,
    };
    ALL_DIRECTIONS.forEach(function (direction) {
        var areaLimit = positionRestrictions[direction];
        var objectLimit = coordinatesToPositionRestrictions(object)[direction];
        if (areaLimit !== undefined && objectLimit !== undefined) {
            if (direction === 'left' || direction === 'top') {
                intersections[direction] = Math.max(0, areaLimit - objectLimit);
            }
            else {
                intersections[direction] = Math.max(0, objectLimit - areaLimit);
            }
        }
        else {
            intersections[direction] = 0;
        }
    });
    return intersections;
}
function resizeToSizeRestrictions(coordinates, sizeRestrictions) {
    return applyScale(coordinates, fitToSizeRestrictions(coordinates, sizeRestrictions));
}
function rotateSize(size, angle) {
    var radians = (angle * Math.PI) / 180;
    return {
        width: Math.abs(size.width * Math.cos(radians)) + Math.abs(size.height * Math.sin(radians)),
        height: Math.abs(size.width * Math.sin(radians)) + Math.abs(size.height * Math.cos(radians)),
    };
}
function rotatePoint(point, angle, anchor) {
    var radians = (angle * Math.PI) / 180;
    if (anchor) {
        return {
            left: (point.left - anchor.left) * Math.cos(radians) -
                (point.top - anchor.top) * Math.sin(radians) +
                anchor.left,
            top: (point.left - anchor.left) * Math.sin(radians) +
                (point.top - anchor.top) * Math.cos(radians) +
                anchor.top,
        };
    }
    else {
        return {
            left: point.left * Math.cos(radians) - point.top * Math.sin(radians),
            top: point.left * Math.sin(radians) + point.top * Math.cos(radians),
        };
    }
}
function positionToSizeRestrictions(positionRestrictions) {
    return {
        minWidth: 0,
        minHeight: 0,
        maxWidth: positionRestrictions.right !== undefined && positionRestrictions.left !== undefined
            ? positionRestrictions.right - positionRestrictions.left
            : Infinity,
        maxHeight: positionRestrictions.bottom !== undefined && positionRestrictions.top !== undefined
            ? positionRestrictions.bottom - positionRestrictions.top
            : Infinity,
    };
}
function mergePositionRestrictions(a, b) {
    var restrictions = {};
    ALL_DIRECTIONS.forEach(function (direction) {
        var firstDirection = a[direction];
        var secondDirection = b[direction];
        if (firstDirection !== undefined && secondDirection !== undefined) {
            if (direction === 'left' || direction === 'top') {
                restrictions[direction] = Math.max(firstDirection, secondDirection);
            }
            else {
                restrictions[direction] = Math.min(firstDirection, secondDirection);
            }
        }
        else if (secondDirection !== undefined) {
            restrictions[direction] = secondDirection;
        }
        else if (firstDirection !== undefined) {
            restrictions[direction] = firstDirection;
        }
    });
    return restrictions;
}
function fitToPositionRestrictions(coordinates, positionRestrictions) {
    var directions = {
        left: 0,
        top: 0,
    };
    var intersection = getIntersections(coordinates, positionRestrictions);
    if (intersection.left && intersection.left > 0) {
        directions.left = intersection.left;
    }
    else if (intersection.right && intersection.right > 0) {
        directions.left = -intersection.right;
    }
    if (intersection.top && intersection.top > 0) {
        directions.top = intersection.top;
    }
    else if (intersection.bottom && intersection.bottom > 0) {
        directions.top = -intersection.bottom;
    }
    return directions;
}
function moveToPositionRestrictions(coordinates, positionRestrictions) {
    return applyMove(coordinates, fitToPositionRestrictions(coordinates, positionRestrictions));
}
function createAspectRatio(aspectRatio) {
    if (aspectRatio === void 0) { aspectRatio = {}; }
    if (isNumber(aspectRatio)) {
        return {
            minimum: aspectRatio,
            maximum: aspectRatio,
        };
    }
    else {
        return {
            minimum: isNumeric(aspectRatio.minimum) ? aspectRatio.minimum : 0,
            maximum: isNumeric(aspectRatio.maximum) ? aspectRatio.maximum : Infinity,
        };
    }
}
function isConsistentSize(size, restrictions) {
    return ((isUndefined(restrictions.maxWidth) || !isGreater(size.width, restrictions.maxWidth)) &&
        (isUndefined(restrictions.maxHeight) || !isGreater(size.height, restrictions.maxHeight)) &&
        (isUndefined(restrictions.minHeight) || !isLower(size.height, restrictions.minHeight)) &&
        (isUndefined(restrictions.minWidth) || !isLower(size.width, restrictions.minWidth)));
}
function getCloserSize(candidates, reference, sizeRestrictions, aspectRatio) {
    var traverse = function (ignoreMinimum) {
        return candidates.reduce(function (minimum, size) {
            var _a = isFunction(sizeRestrictions)
                ? sizeRestrictions(size)
                : sizeRestrictions, maxHeight = _a.maxHeight, maxWidth = _a.maxWidth, minWidth = _a.minWidth, minHeight = _a.minHeight;
            var preparedAspectRatio = createAspectRatio(isFunction(aspectRatio) ? aspectRatio(size) : aspectRatio);
            var preparedSizeRestrictions = ignoreMinimum
                ? { maxWidth: maxWidth, maxHeight: maxHeight }
                : { maxWidth: maxWidth, maxHeight: maxHeight, minWidth: minWidth, minHeight: minHeight };
            if (isConsistentSize(size, preparedSizeRestrictions) &&
                !getBrokenRatio(ratio(size), preparedAspectRatio) &&
                size.width &&
                size.height) {
                return !minimum || isLower(sizeDistance(size, reference), sizeDistance(minimum, reference))
                    ? size
                    : minimum;
            }
            else {
                return minimum;
            }
        }, null);
    };
    return traverse() || traverse(true);
}

function reconcileSizeRestrictions(sizeRestrictions) {
    var restrictions = tslib.__assign({}, sizeRestrictions);
    // Process the border cases when minimum height / width larger than maximum height / width
    if (restrictions.minWidth > restrictions.maxWidth) {
        restrictions.minWidth = restrictions.maxWidth;
    }
    if (restrictions.minHeight > restrictions.maxHeight) {
        restrictions.minHeight = restrictions.maxHeight;
    }
    return restrictions;
}
function mergeSizeRestrictions(a, b) {
    var first = a;
    var second = tslib.__assign({ minWidth: 0, minHeight: 0, maxWidth: Infinity, maxHeight: Infinity }, b);
    return reconcileSizeRestrictions({
        maxHeight: Math.min(first.maxHeight, second.maxHeight),
        minHeight: Math.max(first.minHeight, second.minHeight),
        maxWidth: Math.min(first.maxWidth, second.maxWidth),
        minWidth: Math.max(first.minWidth, second.minWidth),
    });
}
function calculateSizeRestrictions(state, settings) {
    var sizeRestrictions = isFunction(settings.sizeRestrictions)
        ? settings.sizeRestrictions(state, settings)
        : settings.sizeRestrictions;
    var positionRestrictions = getPositionRestrictions(state, settings);
    // User can forget to set some of restrictions, so we should initialize them by default values
    var restrictions = {
        minWidth: isNumeric(sizeRestrictions.minWidth) ? parseNumber(sizeRestrictions.minWidth) : 0,
        minHeight: isNumeric(sizeRestrictions.minHeight) ? parseNumber(sizeRestrictions.minHeight) : 0,
        maxWidth: isNumeric(sizeRestrictions.maxWidth) ? parseNumber(sizeRestrictions.maxWidth) : Infinity,
        maxHeight: isNumeric(sizeRestrictions.maxHeight) ? parseNumber(sizeRestrictions.maxHeight) : Infinity,
    };
    // The situation, when stencil can't be positioned in cropper due to positionRestrictions should be avoided
    if (positionRestrictions.left !== undefined && positionRestrictions.right !== undefined) {
        restrictions.maxWidth = Math.min(restrictions.maxWidth, positionRestrictions.right - positionRestrictions.left);
    }
    if (positionRestrictions.bottom !== undefined && positionRestrictions.top !== undefined) {
        restrictions.maxHeight = Math.min(restrictions.maxHeight, positionRestrictions.bottom - positionRestrictions.top);
    }
    return reconcileSizeRestrictions(restrictions);
}
function calculateAreaSizeRestrictions(state, settings) {
    var sizeRestrictions = isFunction(settings.areaSizeRestrictions)
        ? settings.areaSizeRestrictions(state, settings)
        : settings.areaSizeRestrictions;
    if (sizeRestrictions.maxWidth < Infinity && sizeRestrictions.maxHeight < Infinity) {
        if (ratio(state.boundary) > sizeRestrictions.maxWidth / sizeRestrictions.maxHeight) {
            sizeRestrictions.maxHeight = sizeRestrictions.maxWidth / ratio(state.boundary);
        }
        else {
            sizeRestrictions.maxWidth = sizeRestrictions.maxHeight * ratio(state.boundary);
        }
    }
    return reconcileSizeRestrictions(sizeRestrictions);
}

function isInitializedState(state) {
    return Boolean(state && state.visibleArea && state.coordinates);
}
function getAreaSizeRestrictions(state, settings) {
    return calculateAreaSizeRestrictions(state, settings);
}
function getAreaPositionRestrictions(state, settings) {
    return isFunction(settings.areaPositionRestrictions)
        ? settings.areaPositionRestrictions(state, settings)
        : settings.areaPositionRestrictions;
}
function getSizeRestrictions(state, settings) {
    return calculateSizeRestrictions(state, settings);
}
function getPositionRestrictions(state, settings) {
    return isFunction(settings.positionRestrictions)
        ? settings.positionRestrictions(state, settings)
        : settings.positionRestrictions;
}
function getCoefficient(state) {
    return state.visibleArea ? state.visibleArea.width / state.boundary.width : 0;
}
function getAspectRatio(state, settings) {
    return createAspectRatio(isFunction(settings.aspectRatio) ? settings.aspectRatio(state, settings) : settings.aspectRatio);
}
function getTransformedImageSize(state) {
    if (state.imageSize && state.imageSize.width && state.imageSize.height) {
        return rotateSize(state.imageSize, state.transforms.rotate);
    }
    else {
        return {
            width: 0,
            height: 0,
        };
    }
}
function getMinimumSize(state) {
    // The magic number is the approximation of the handler size
    // Temporary solution that should be improved in the future
    return state.coordinates
        ? Math.min(state.coordinates.width, state.coordinates.height, 20 * getCoefficient(state))
        : 1;
}

function copyState(state) {
    return deepClone(state);
}

var ImageRestriction;
(function (ImageRestriction) {
    ImageRestriction["fillArea"] = "fillArea";
    ImageRestriction["fitArea"] = "fitArea";
    ImageRestriction["stencil"] = "stencil";
    ImageRestriction["none"] = "none";
})(ImageRestriction || (ImageRestriction = {}));
var Priority;
(function (Priority) {
    Priority["coordinates"] = "coordinates";
    Priority["visibleArea"] = "visibleArea";
})(Priority || (Priority = {}));

// Limitations:
// 1. Assume that maximum width and height always larger than minimum width and height
// 2. Assume that aspectRatio.minimum < aspectRatio.maximum
// If you break this limitations function could return null!
function approximateSize(params) {
    var width = params.width, height = params.height;
    var sizeRestrictions = params.sizeRestrictions || {
        minWidth: 0,
        minHeight: 0,
        maxWidth: Infinity,
        maxHeight: Infinity,
    };
    var aspectRatio = createAspectRatio(params.aspectRatio);
    var coordinates = {
        width: Math.max(sizeRestrictions.minWidth, Math.min(sizeRestrictions.maxWidth, width)),
        height: Math.max(sizeRestrictions.minHeight, Math.min(sizeRestrictions.maxHeight, height)),
    };
    var candidates = [coordinates];
    if (aspectRatio) {
        [aspectRatio.minimum, aspectRatio.maximum].forEach(function (ratio) {
            if (ratio) {
                candidates.push({ width: coordinates.width, height: coordinates.width / ratio }, { width: coordinates.height * ratio, height: coordinates.height });
            }
        });
    }
    // Resize the candidates as much as possible to prevent breaking minimum size
    candidates = candidates.map(function (candidate) { return resizeToSizeRestrictions(candidate, sizeRestrictions); });
    // TODO: fix the type of return value
    return getCloserSize(candidates, { width: width, height: height }, sizeRestrictions, aspectRatio);
}

function moveCoordinatesAlgorithm(coordinates, directions, positionRestrictions) {
    var movedCoordinates = applyMove(coordinates, directions);
    return positionRestrictions ? moveToPositionRestrictions(movedCoordinates, positionRestrictions) : movedCoordinates;
}

var SetCoordinatesMode;
(function (SetCoordinatesMode) {
    SetCoordinatesMode["limit"] = "limit";
    SetCoordinatesMode["zoom"] = "zoom";
    SetCoordinatesMode["unsafe"] = "unsafe";
})(SetCoordinatesMode || (SetCoordinatesMode = {}));

function rotateImageAlgorithm(state, settings, rotate) {
    if (isInitializedState(state)) {
        var result = copyState(state);
        var angle = isNumber(rotate) ? rotate : rotate.angle;
        var imageCenter = rotatePoint(getCenter(tslib.__assign({ left: 0, top: 0 }, getTransformedImageSize(state))), angle);
        result.transforms.rotate += angle;
        result.coordinates = tslib.__assign(tslib.__assign({}, approximateSize({
            sizeRestrictions: getSizeRestrictions(result, settings),
            aspectRatio: getAspectRatio(result, settings),
            width: result.coordinates.width,
            height: result.coordinates.height,
        })), rotatePoint(getCenter(result.coordinates), angle));
        var center = !isNumber(rotate) && rotate.center ? rotate.center : getCenter(state.coordinates);
        var shift = diff(getCenter(state.coordinates), rotatePoint(getCenter(state.coordinates), angle, center));
        var imageSize = getTransformedImageSize(result);
        result.coordinates.left -= imageCenter.left - imageSize.width / 2 + result.coordinates.width / 2 - shift.left;
        result.coordinates.top -= imageCenter.top - imageSize.height / 2 + result.coordinates.height / 2 - shift.top;
        // Check that visible area doesn't break the area restrictions:
        result.visibleArea = resizeToSizeRestrictions(result.visibleArea, mergeSizeRestrictions(getAreaSizeRestrictions(result, settings), {
            minWidth: result.coordinates.width,
            minHeight: result.coordinates.height,
        }));
        result.coordinates = moveToPositionRestrictions(result.coordinates, getPositionRestrictions(result, settings));
        result.visibleArea = applyMove(result.visibleArea, diff(getCenter(result.coordinates), getCenter(state.coordinates)));
        result.visibleArea = moveToPositionRestrictions(result.visibleArea, getAreaPositionRestrictions(result, settings));
        return result;
    }
    return state;
}

function flipImageAlgorithm(state, settings, horizontal, vertical) {
    if (isInitializedState(state)) {
        var result = copyState(state);
        var rotate = state.transforms.rotate;
        var imageSize = getTransformedImageSize(state);
        var changed = {
            horizontal: horizontal,
            vertical: vertical,
        };
        if (changed.horizontal || changed.vertical) {
            var imageCenter = rotatePoint({
                left: imageSize.width / 2,
                top: imageSize.height / 2,
            }, -rotate);
            var oldCenter = rotatePoint(getCenter(result.coordinates), -rotate);
            var newCenter = rotatePoint({
                left: changed.horizontal ? imageCenter.left - (oldCenter.left - imageCenter.left) : oldCenter.left,
                top: changed.vertical ? imageCenter.top - (oldCenter.top - imageCenter.top) : oldCenter.top,
            }, rotate);
            result.coordinates = applyMove(result.coordinates, diff(newCenter, getCenter(result.coordinates)));
            oldCenter = rotatePoint(getCenter(result.visibleArea), -rotate);
            newCenter = rotatePoint({
                left: changed.horizontal ? imageCenter.left - (oldCenter.left - imageCenter.left) : oldCenter.left,
                top: changed.vertical ? imageCenter.top - (oldCenter.top - imageCenter.top) : oldCenter.top,
            }, rotate);
            result.visibleArea = applyMove(result.visibleArea, diff(newCenter, getCenter(result.visibleArea)));
            result.visibleArea = moveToPositionRestrictions(result.visibleArea, getAreaPositionRestrictions(result, settings));
        }
        if (changed.horizontal) {
            result.transforms.flip.horizontal = !state.transforms.flip.horizontal;
        }
        if (changed.vertical) {
            result.transforms.flip.vertical = !state.transforms.flip.vertical;
        }
        return result;
    }
    return state;
}

function transformImageAlgorithm(state, settings, transform) {
    var _a;
    var _b = transform.scale, scale = _b === void 0 ? 1 : _b, _c = transform.move, move = _c === void 0 ? {} : _c;
    if (isInitializedState(state)) {
        var result = copyState(state);
        // It's reversed because zooming in the image is actually zooming out visible area
        var scaleFactor = 1 / (isNumber(scale) ? scale : scale.factor);
        var scaleCenter = !isNumber(scale) ? scale.center : undefined;
        var isAllowedScale = !isRoughlyEqual(scaleFactor, 1);
        var areaScale = 1;
        var stencilScale = 1;
        result.visibleArea = applyMove(result.visibleArea, {
            left: move.left || 0,
            top: move.top || 0,
        });
        var sizeRestrictions = getSizeRestrictions(result, settings);
        var positionRestrictions = getPositionRestrictions(result, settings);
        var areaSizeRestrictions = getAreaSizeRestrictions(result, settings);
        var scaleRestrictions = {
            stencil: {
                minimum: Math.max(sizeRestrictions.minWidth ? sizeRestrictions.minWidth / result.coordinates.width : 0, sizeRestrictions.minHeight ? sizeRestrictions.minHeight / result.coordinates.height : 0),
                maximum: Math.min(sizeRestrictions.maxWidth ? sizeRestrictions.maxWidth / result.coordinates.width : Infinity, sizeRestrictions.maxHeight ? sizeRestrictions.maxHeight / result.coordinates.height : Infinity, maxScale(result.coordinates, positionToSizeRestrictions(positionRestrictions))),
            },
            area: {
                maximum: maxScale(result.visibleArea, areaSizeRestrictions),
                minimum: minScale(result.visibleArea, areaSizeRestrictions),
            },
        };
        // If there is scaling then begin scale
        if (scaleFactor && isAllowedScale) {
            // Determine scale factor
            if (scaleFactor < 1) {
                stencilScale = Math.max(scaleFactor, Math.max(scaleRestrictions.area.minimum, scaleRestrictions.stencil.minimum));
                if (stencilScale > 1) {
                    stencilScale = 1;
                }
            }
            else if (scaleFactor > 1) {
                stencilScale = Math.min(scaleFactor, Math.min(scaleRestrictions.area.maximum, scaleRestrictions.stencil.maximum));
                if (stencilScale < 1) {
                    stencilScale = 1;
                }
            }
        }
        if (stencilScale) {
            // Resize stencil with area as much as possible
            result.visibleArea = applyScale(result.visibleArea, stencilScale, scaleCenter);
        }
        var relativeCoordinates = {
            left: state.coordinates.left - state.visibleArea.left,
            right: state.visibleArea.width + state.visibleArea.left - (state.coordinates.width + state.coordinates.left),
            top: state.coordinates.top - state.visibleArea.top,
            bottom: state.visibleArea.height + state.visibleArea.top - (state.coordinates.height + state.coordinates.top),
        };
        // Move the area to fit to the coordinates limits:
        result.visibleArea = moveToPositionRestrictions(result.visibleArea, {
            left: positionRestrictions.left !== undefined
                ? positionRestrictions.left - relativeCoordinates.left * stencilScale
                : undefined,
            top: positionRestrictions.top !== undefined
                ? positionRestrictions.top - relativeCoordinates.top * stencilScale
                : undefined,
            bottom: positionRestrictions.bottom !== undefined
                ? positionRestrictions.bottom + relativeCoordinates.bottom * stencilScale
                : undefined,
            right: positionRestrictions.right !== undefined
                ? positionRestrictions.right + relativeCoordinates.right * stencilScale
                : undefined,
        });
        // But the more important to fit are to the area restrictions, so we should fit it to that restrictions:
        result.visibleArea = moveToPositionRestrictions(result.visibleArea, getAreaPositionRestrictions(result, settings));
        // Set the same coordinates of stencil inside visible area
        result.coordinates.width = result.coordinates.width * stencilScale;
        result.coordinates.height = result.coordinates.height * stencilScale;
        result.coordinates.left = result.visibleArea.left + relativeCoordinates.left * stencilScale;
        result.coordinates.top = result.visibleArea.top + relativeCoordinates.top * stencilScale;
        // Move the coordinates to prevent the intersection with visible area and position restrictions
        result.coordinates = moveToPositionRestrictions(result.coordinates, mergePositionRestrictions(coordinatesToPositionRestrictions(result.visibleArea), positionRestrictions));
        // Resize only area if stencil can't be resized and stencil resize is disabled
        if (isAllowedScale && scaleFactor && ((_a = settings.transformImage) === null || _a === void 0 ? void 0 : _a.adjustStencil)) {
            if (scaleFactor > 1) {
                areaScale = Math.min(scaleRestrictions.area.maximum, scaleFactor) / stencilScale;
            }
            else if (scaleFactor < 1) {
                areaScale = Math.max(result.coordinates.height / result.visibleArea.height, result.coordinates.width / result.visibleArea.width, scaleFactor / stencilScale);
            }
            if (areaScale !== 1) {
                result.visibleArea = applyScale(result.visibleArea, areaScale, scaleFactor > 1 ? scaleCenter : getCenter(result.coordinates));
                // Move to prevent the breaking of the area restrictions:
                result.visibleArea = moveToPositionRestrictions(result.visibleArea, getAreaPositionRestrictions(result, settings));
                // Move to prevent the intersection with coordinates:
                result.visibleArea = applyMove(result.visibleArea, inverseMove(fitToPositionRestrictions(result.coordinates, coordinatesToPositionRestrictions(result.visibleArea))));
            }
        }
        return result;
    }
    return state;
}

function transformImage$1(state, settings, transform) {
    if (transform.rotate) {
        state = rotateImageAlgorithm(state, settings, transform.rotate);
    }
    if (transform.flip) {
        state = flipImageAlgorithm(state, settings, transform.flip.horizontal, transform.flip.vertical);
    }
    if (transform.move || transform.scale) {
        state = transformImageAlgorithm(state, settings, transform);
    }
    return state;
}

function fitDirections(_a) {
    var coordinates = _a.coordinates, directions = _a.directions, positionRestrictions = _a.positionRestrictions, sizeRestrictions = _a.sizeRestrictions, preserveRatio = _a.preserveRatio, compensate = _a.compensate;
    var fittedDirections = tslib.__assign({}, directions);
    var currentWidth = applyDirections(coordinates, fittedDirections).width;
    var currentHeight = applyDirections(coordinates, fittedDirections).height;
    // Prevent strange resizes when the width or height of stencil becomes smaller than 0
    if (currentWidth < 0) {
        if (fittedDirections.left < 0 && fittedDirections.right < 0) {
            fittedDirections.left =
                -(coordinates.width - sizeRestrictions.minWidth) / (fittedDirections.left / fittedDirections.right);
            fittedDirections.right =
                -(coordinates.width - sizeRestrictions.minWidth) / (fittedDirections.right / fittedDirections.left);
        }
        else if (fittedDirections.left < 0) {
            fittedDirections.left = -(coordinates.width - sizeRestrictions.minWidth);
        }
        else if (fittedDirections.right < 0) {
            fittedDirections.right = -(coordinates.width - sizeRestrictions.minWidth);
        }
    }
    if (currentHeight < 0) {
        if (fittedDirections.top < 0 && fittedDirections.bottom < 0) {
            fittedDirections.top =
                -(coordinates.height - sizeRestrictions.minHeight) / (fittedDirections.top / fittedDirections.bottom);
            fittedDirections.bottom =
                -(coordinates.height - sizeRestrictions.minHeight) / (fittedDirections.bottom / fittedDirections.top);
        }
        else if (fittedDirections.top < 0) {
            fittedDirections.top = -(coordinates.height - sizeRestrictions.minHeight);
        }
        else if (fittedDirections.bottom < 0) {
            fittedDirections.bottom = -(coordinates.height - sizeRestrictions.minHeight);
        }
    }
    // Prevent breaking limits
    var breaks = getIntersections(applyDirections(coordinates, fittedDirections), positionRestrictions);
    if (compensate) {
        if (breaks.left && breaks.left > 0 && breaks.right === 0) {
            fittedDirections.right += breaks.left;
            fittedDirections.left -= breaks.left;
        }
        else if (breaks.right && breaks.right > 0 && breaks.left === 0) {
            fittedDirections.left += breaks.right;
            fittedDirections.right -= breaks.right;
        }
        if (breaks.top && breaks.top > 0 && breaks.bottom === 0) {
            fittedDirections.bottom += breaks.top;
            fittedDirections.top -= breaks.top;
        }
        else if (breaks.bottom && breaks.bottom > 0 && breaks.top === 0) {
            fittedDirections.top += breaks.bottom;
            fittedDirections.bottom -= breaks.bottom;
        }
        breaks = getIntersections(applyDirections(coordinates, fittedDirections), positionRestrictions);
    }
    var maxResize = {
        width: Infinity,
        height: Infinity,
        left: Infinity,
        right: Infinity,
        top: Infinity,
        bottom: Infinity,
    };
    ALL_DIRECTIONS.forEach(function (direction) {
        var intersection = breaks[direction];
        if (intersection && fittedDirections[direction]) {
            maxResize[direction] = Math.max(0, 1 - intersection / fittedDirections[direction]);
        }
    });
    if (preserveRatio) {
        var multiplier_1 = Math.min.apply(Math, ALL_DIRECTIONS.map(function (direction) { return maxResize[direction]; }));
        if (multiplier_1 !== Infinity) {
            ALL_DIRECTIONS.forEach(function (direction) {
                fittedDirections[direction] *= multiplier_1;
            });
        }
    }
    else {
        ALL_DIRECTIONS.forEach(function (direction) {
            if (maxResize[direction] !== Infinity) {
                fittedDirections[direction] *= maxResize[direction];
            }
        });
    }
    currentWidth = applyDirections(coordinates, fittedDirections).width;
    currentHeight = applyDirections(coordinates, fittedDirections).height;
    if (fittedDirections.right + fittedDirections.left) {
        if (currentWidth > sizeRestrictions.maxWidth) {
            maxResize.width =
                (sizeRestrictions.maxWidth - coordinates.width) / (fittedDirections.right + fittedDirections.left);
        }
        else if (currentWidth < sizeRestrictions.minWidth) {
            maxResize.width =
                (sizeRestrictions.minWidth - coordinates.width) / (fittedDirections.right + fittedDirections.left);
        }
    }
    if (fittedDirections.bottom + fittedDirections.top) {
        if (currentHeight > sizeRestrictions.maxHeight) {
            maxResize.height =
                (sizeRestrictions.maxHeight - coordinates.height) / (fittedDirections.bottom + fittedDirections.top);
        }
        else if (currentHeight < sizeRestrictions.minHeight) {
            maxResize.height =
                (sizeRestrictions.minHeight - coordinates.height) / (fittedDirections.bottom + fittedDirections.top);
        }
    }
    if (preserveRatio) {
        var multiplier_2 = Math.min(maxResize.width, maxResize.height);
        if (multiplier_2 !== Infinity) {
            ALL_DIRECTIONS.forEach(function (direction) {
                fittedDirections[direction] *= multiplier_2;
            });
        }
    }
    else {
        if (maxResize.width !== Infinity) {
            HORIZONTAL_DIRECTIONS.forEach(function (direction) {
                fittedDirections[direction] *= maxResize.width;
            });
        }
        if (maxResize.height !== Infinity) {
            VERTICAL_DIRECTIONS.forEach(function (direction) {
                fittedDirections[direction] *= maxResize.height;
            });
        }
    }
    return fittedDirections;
}
function distributeOverlap(overlap, first, second) {
    if (isRoughlyEqual(first + second, 0)) {
        return overlap / 2;
    }
    else if (isRoughlyEqual(first, 0)) {
        return 0;
    }
    else if (isRoughlyEqual(second, 0)) {
        return overlap;
    }
    else {
        return overlap * Math.abs(first / (first + second));
    }
}
function resizeCoordinatesAlgorithm(coordinates, directions, options, limitations) {
    var aspectRatio = limitations.aspectRatio, positionRestrictions = limitations.positionRestrictions, sizeRestrictions = limitations.sizeRestrictions;
    var actualCoordinates = tslib.__assign(tslib.__assign({}, coordinates), { right: coordinates.left + coordinates.width, bottom: coordinates.top + coordinates.height });
    directions = tslib.__assign({}, directions);
    var allowedDirections = options.allowedDirections || {
        left: true,
        right: true,
        bottom: true,
        top: true,
    };
    // It's possible that coordinates can be smaller than minimum width or minimum height. In this case
    // corresponding resize should be blocked
    if (coordinates.width < sizeRestrictions.minWidth) {
        directions.left = 0;
        directions.right = 0;
    }
    if (coordinates.height < sizeRestrictions.minHeight) {
        directions.top = 0;
        directions.bottom = 0;
    }
    ALL_DIRECTIONS.forEach(function (direction) {
        if (!allowedDirections[direction]) {
            directions[direction] = 0;
        }
    });
    // 1. First step: determine the safe and desired area
    directions = fitDirections({
        coordinates: actualCoordinates,
        directions: directions,
        sizeRestrictions: sizeRestrictions,
        positionRestrictions: positionRestrictions,
    });
    // 2. Second step: fix desired box to correspondent to aspect ratio
    var currentWidth = applyDirections(actualCoordinates, directions).width;
    var currentHeight = applyDirections(actualCoordinates, directions).height;
    // Checks ratio:
    var ratioBroken = options.preserveAspectRatio
        ? ratio(actualCoordinates)
        : getBrokenRatio(currentWidth / currentHeight, aspectRatio);
    if (ratioBroken) {
        var respectDirection = options.respectDirection;
        if (respectDirection !== 'width' && respectDirection !== 'height') {
            if (actualCoordinates.width >= actualCoordinates.height || ratioBroken === 1) {
                respectDirection = 'width';
            }
            else {
                respectDirection = 'height';
            }
        }
        if (respectDirection === 'width') {
            var overlapHeight = currentWidth / ratioBroken - actualCoordinates.height;
            if (allowedDirections.top && allowedDirections.bottom) {
                var top_1 = directions.top, bottom = directions.bottom;
                directions.bottom = distributeOverlap(overlapHeight, bottom, top_1);
                directions.top = distributeOverlap(overlapHeight, top_1, bottom);
            }
            else if (allowedDirections.bottom) {
                directions.bottom = overlapHeight;
            }
            else if (allowedDirections.top) {
                directions.top = overlapHeight;
            }
            else if (allowedDirections.right) {
                directions.right = 0;
            }
            else if (allowedDirections.left) {
                directions.left = 0;
            }
        }
        else if (respectDirection === 'height') {
            var overlapWidth = actualCoordinates.width - currentHeight * ratioBroken;
            if (allowedDirections.left && allowedDirections.right) {
                var left = directions.left, right = directions.right;
                directions.left = -distributeOverlap(overlapWidth, left, right);
                directions.right = -distributeOverlap(overlapWidth, right, left);
            }
            else if (allowedDirections.left) {
                directions.left = -overlapWidth;
            }
            else if (allowedDirections.right) {
                directions.right = -overlapWidth;
            }
            else if (allowedDirections.top) {
                directions.top = 0;
            }
            else if (allowedDirections.bottom) {
                directions.bottom = 0;
            }
        }
        // 3. Third step: check if desired box with correct aspect ratios break some limits and fit to this conditions
        directions = fitDirections({
            directions: directions,
            coordinates: actualCoordinates,
            sizeRestrictions: sizeRestrictions,
            positionRestrictions: positionRestrictions,
            preserveRatio: true,
            compensate: options.compensate,
        });
    }
    // 4. Check if ratio broken (temporary):
    currentWidth = applyDirections(actualCoordinates, directions).width;
    currentHeight = applyDirections(actualCoordinates, directions).height;
    ratioBroken = options.preserveAspectRatio
        ? ratio(actualCoordinates)
        : getBrokenRatio(currentWidth / currentHeight, aspectRatio);
    if (ratioBroken && Math.abs(ratioBroken - currentWidth / currentHeight) > 1e-3) {
        ALL_DIRECTIONS.forEach(function (direction) {
            if (!allowedDirections[direction]) {
                directions[direction] = 0;
            }
        });
    }
    return moveCoordinatesAlgorithm({
        width: coordinates.width + directions.right + directions.left,
        height: coordinates.height + directions.top + directions.bottom,
        left: coordinates.left,
        top: coordinates.top,
    }, {
        left: -directions.left,
        top: -directions.top,
    }, positionRestrictions);
}

function defaultStencilConstraints(rawSettings, stencilProps) {
    if (!rawSettings.aspectRatio) {
        return {
            aspectRatio: createAspectRatio(isFunction(stencilProps.aspectRatio) ? stencilProps.aspectRatio() : stencilProps.aspectRatio),
        };
    }
    return {};
}

var BoundingBoxType;
(function (BoundingBoxType) {
    BoundingBoxType["Circle"] = "circle";
    BoundingBoxType["Rectangle"] = "rectangle";
})(BoundingBoxType || (BoundingBoxType = {}));

function circleBoundingBox(size, angle) {
    return size;
}
function rectangleBoundingBox(size, angle) {
    return rotateSize(size, angle);
}
function getBoundingBox(size, angle, algorithm) {
    if (algorithm === BoundingBoxType.Circle) {
        return circleBoundingBox(size);
    }
    else {
        return rectangleBoundingBox(size, angle);
    }
}

function imageToSizeRestrictions(image, aspectRatio, boundingBox) {
    var wrapper = getBoundingBox({
        width: aspectRatio,
        height: 1,
    }, image.angle, boundingBox);
    if (ratio(image) >= ratio(wrapper)) {
        return {
            minWidth: 0,
            minHeight: 0,
            maxHeight: image.height / wrapper.height,
            maxWidth: (image.height / wrapper.height) * aspectRatio,
        };
    }
    else {
        return {
            minWidth: 0,
            minHeight: 0,
            maxHeight: image.width / wrapper.width,
            maxWidth: (image.width / wrapper.width) * aspectRatio,
        };
    }
}
function approximateSizeInsideImage(params) {
    var width = params.width, height = params.height, image = params.image, sizeRestrictions = params.sizeRestrictions, _a = params.boundingBox, boundingBox = _a === void 0 ? BoundingBoxType.Rectangle : _a;
    var aspectRatio = createAspectRatio(params.aspectRatio);
    // Try to place the desired coordinates with respect to minimum size
    var coordinates = {
        width: Math.max(sizeRestrictions.minWidth, width),
        height: Math.max(sizeRestrictions.minHeight, height),
    };
    // Bounding box for the current coordinates
    var angleRestrictions = imageToSizeRestrictions(image, Math.min(aspectRatio.maximum, Math.max(aspectRatio.minimum, ratio(coordinates))), boundingBox);
    // Consider the current size and the cropped by maximum bounding box size
    var candidates = [
        coordinates,
        {
            width: Math.min(sizeRestrictions.maxWidth, angleRestrictions.maxWidth),
            height: Math.min(sizeRestrictions.maxHeight, angleRestrictions.maxHeight),
        },
    ];
    // If we have some aspect ratio
    [aspectRatio.minimum, aspectRatio.maximum].forEach(function (ratio) {
        if (ratio && ratio !== Infinity) {
            var fittedSizeRestrictions = mergeSizeRestrictions(sizeRestrictions, imageToSizeRestrictions(image, ratio, boundingBox));
            var width_1 = Math.min(coordinates.width, fittedSizeRestrictions.maxWidth);
            var height_1 = Math.min(coordinates.height, fittedSizeRestrictions.maxHeight);
            candidates.push({ width: width_1, height: width_1 / ratio }, { width: height_1 * ratio, height: height_1 });
        }
    });
    // Resize the candidates as much as possible to prevent breaking minimum size
    candidates = candidates.map(function (candidate) {
        return resizeToSizeRestrictions(candidate, mergeSizeRestrictions(imageToSizeRestrictions(image, ratio(candidate), boundingBox), sizeRestrictions));
    });
    var candidate = getCloserSize(candidates, { width: width, height: height }, function (size) { return mergeSizeRestrictions(sizeRestrictions, imageToSizeRestrictions(image, ratio(size), boundingBox)); }, aspectRatio);
    return candidate;
}

function fitToImage(coordinates, image, boundingBox) {
    if (boundingBox === void 0) { boundingBox = BoundingBoxType.Rectangle; }
    var imageCenter = getCenter(tslib.__assign({ left: 0, top: 0 }, rotateSize(image, -image.angle)));
    var center = rotatePoint(getCenter(coordinates), -image.angle, imageCenter);
    var boundingBoxSize = getBoundingBox(coordinates, image.angle, boundingBox);
    var boundingBoxCoordinates = tslib.__assign(tslib.__assign({}, boundingBoxSize), { left: center.left - boundingBoxSize.width / 2, top: center.top - boundingBoxSize.height / 2 });
    var vector = fitToPositionRestrictions(boundingBoxCoordinates, {
        left: imageCenter.left - image.width / 2,
        top: imageCenter.top - image.height / 2,
        right: imageCenter.left + image.width / 2,
        bottom: imageCenter.top + image.height / 2,
    });
    var leftVector = rotatePoint({ left: vector.left, top: 0 }, image.angle);
    var topVector = rotatePoint({ left: 0, top: vector.top }, image.angle);
    return {
        left: leftVector.left + topVector.left,
        top: leftVector.top + topVector.top,
    };
}
function moveToImage(coordinates, image, boundingBox) {
    if (boundingBox === void 0) { boundingBox = BoundingBoxType.Rectangle; }
    return applyMove(coordinates, fitToImage(coordinates, image, boundingBox));
}

function getRotatedImage(state) {
    return {
        width: state.imageSize.width,
        height: state.imageSize.height,
        angle: state.transforms.rotate,
    };
}

function stencilConstraints(rawSettings, stencilOptions) {
    var defaultConstraints = defaultStencilConstraints({}, stencilOptions);
    return tslib.__assign({ stencilBoundingBox: stencilOptions.boundingBox }, defaultConstraints);
}
function transformImage(state, settings, transform) {
    var flip = transform.flip, rotate = transform.rotate, scale = transform.scale, move = transform.move;
    if (flip) {
        state = tslib.__assign(tslib.__assign({}, state), { transforms: tslib.__assign(tslib.__assign({}, state.transforms), { flip: {
                    horizontal: flip.horizontal ? !state.transforms.flip.horizontal : state.transforms.flip.horizontal,
                    vertical: flip.vertical ? !state.transforms.flip.vertical : state.transforms.flip.vertical,
                } }) });
    }
    if (state.coordinates) {
        if (!flip && !scale && !move) {
            state.basis = state.basis || tslib.__assign({}, state.coordinates);
        }
        else {
            state.basis = undefined;
        }
    }
    return transformImage$1(state, settings, { rotate: rotate, move: move, scale: scale });
}
function resizeCoordinates(state, settings, directions, options) {
    if (isInitializedState(state)) {
        var result = copyState(state);
        var minimumSize = getMinimumSize(result);
        var imageSize = getTransformedImageSize(result);
        var sizeRestrictions = getSizeRestrictions(result, settings);
        result.coordinates = resizeCoordinatesAlgorithm(result.coordinates, directions, options, {
            positionRestrictions: mergePositionRestrictions(getPositionRestrictions(result, settings), coordinatesToPositionRestrictions(result.visibleArea)),
            sizeRestrictions: {
                maxWidth: Math.min(sizeRestrictions.maxWidth, imageSize.width, result.visibleArea.width),
                maxHeight: Math.min(sizeRestrictions.maxHeight, imageSize.height, result.visibleArea.height),
                minWidth: Math.max(Math.min(sizeRestrictions.minWidth, result.visibleArea.width), minimumSize),
                minHeight: Math.max(Math.min(sizeRestrictions.minHeight, result.visibleArea.height), minimumSize),
            },
            aspectRatio: getAspectRatio(result, settings),
        });
        var resizedCoordinates = tslib.__assign({}, result.coordinates);
        var approximatedSize = approximateSizeInsideImage({
            width: result.coordinates.width,
            height: result.coordinates.height,
            image: getRotatedImage(result),
            boundingBox: settings.stencilBoundingBox,
            aspectRatio: getAspectRatio(result, settings),
            sizeRestrictions: getSizeRestrictions(result, settings),
        });
        result.coordinates = tslib.__assign({ left: getCenter(resizedCoordinates).left - approximatedSize.width / 2, top: getCenter(resizedCoordinates).top - approximatedSize.height / 2 }, approximatedSize);
        if (isGreater(Math.abs(resizedCoordinates.height - result.coordinates.height), 0)) {
            result.visibleArea = applyScale(result.visibleArea, result.visibleArea.height /
                (result.visibleArea.height + resizedCoordinates.height - result.coordinates.height));
        }
        var fitDirections = fitToImage(result.coordinates, getRotatedImage(result), settings.stencilBoundingBox);
        result.coordinates = applyMove(result.coordinates, fitDirections);
        result.visibleArea = applyMove(result.visibleArea, fitDirections);
        return result;
    }
    return state;
}
function defaultSize(state, settings) {
    var imageSize = getTransformedImageSize(state);
    return {
        width: state.visibleArea ? state.visibleArea.width : imageSize.width,
        height: state.visibleArea ? state.visibleArea.height : imageSize.height,
    };
}
function fitStencilToImage(state, settings, action) {
    if (isInitializedState(state) && action.immediately) {
        var result = copyState(state);
        if (action.name !== 'transformImage' && action.name !== 'transformImageEnd') {
            if (!deepCompare(result.coordinates, result.basis)) {
                result.basis = undefined;
            }
        }
        var _a = settings.stencilBoundingBox, stencilBoundingBox = _a === void 0 ? BoundingBoxType.Rectangle : _a;
        var desiredSize = result.basis ? result.basis : result.coordinates;
        var size = approximateSizeInsideImage({
            width: desiredSize.width,
            height: desiredSize.height,
            image: getRotatedImage(state),
            aspectRatio: getAspectRatio(result, settings),
            sizeRestrictions: getSizeRestrictions(result, settings),
            boundingBox: stencilBoundingBox,
        });
        var previousCenter = getCenter(result.coordinates);
        var currentCenter = getCenter(tslib.__assign(tslib.__assign({}, result.coordinates), size));
        // Return to the original position adjusted for size's change
        result.coordinates = applyMove(tslib.__assign(tslib.__assign({}, result.coordinates), size), diff(previousCenter, currentCenter));
        // Move to fit image
        result.coordinates = moveToImage(result.coordinates, getRotatedImage(result), stencilBoundingBox);
        result.visibleArea = applyMove(result.visibleArea, inverseMove(fitToPositionRestrictions(result.coordinates, coordinatesToPositionRestrictions(result.visibleArea))));
        return result;
    }
    return state;
}
function zoomStencil(state, settings, action) {
    if (isInitializedState(state) && action.immediately) {
        var result = copyState(state);
        // Auto size
        var stencil = {
            width: 0,
            height: 0,
        };
        if (ratio(result.boundary) > ratio(result.coordinates)) {
            stencil.height = result.boundary.height;
            stencil.width = stencil.height * ratio(result.coordinates);
        }
        else {
            stencil.width = result.boundary.width;
            stencil.height = stencil.width * ratio(result.coordinates);
        }
        // First of all try to resize visible area as much as possible:
        result.visibleArea = applyScale(result.visibleArea, (result.coordinates.width * result.boundary.width) / (result.visibleArea.width * stencil.width));
        if (ratio(result.boundary) > ratio(result.coordinates)) {
            result.visibleArea.top = result.coordinates.top;
            result.visibleArea.left =
                result.coordinates.left - result.visibleArea.width / 2 + result.coordinates.width / 2;
        }
        else {
            result.visibleArea.left = result.coordinates.left;
            result.visibleArea.top =
                result.coordinates.top - result.visibleArea.height / 2 + result.coordinates.height / 2;
        }
        return result;
    }
    return state;
}

var Spinner = function (_a) {
    var className = _a.className;
    return (React__default["default"].createElement("svg", { className: className, width: "38", height: "38", viewBox: "0 0 38 38", xmlns: "http://www.w3.org/2000/svg" },
        React__default["default"].createElement("g", { fill: "none", fillRule: "evenodd" },
            React__default["default"].createElement("g", { transform: "translate(1 1)", strokeWidth: "2" },
                React__default["default"].createElement("circle", { strokeOpacity: ".5", cx: "18", cy: "18", r: "18" }),
                React__default["default"].createElement("path", { d: "M36 18c0-9.94-8.06-18-18-18" },
                    React__default["default"].createElement("animateTransform", { attributeName: "transform", type: "rotate", from: "0 18 18", to: "360 18 18", dur: "1s", repeatCount: "indefinite" }))))));
};

var CropperWrapper = function (_a) {
    var cropper = _a.cropper, children = _a.children, loaded = _a.loaded, loading = _a.loading, className = _a.className, spinnerClassName = _a.spinnerClassName, navigation = _a.navigation, _b = _a.navigationProps, navigationProps = _b === void 0 ? {} : _b;
    var navigationRef = React.useRef(null);
    var state = cropper.getState();
    var transitions = cropper.getTransitions();
    var rotate = cropper.getTransforms().rotate;
    React.useEffect(function () {
        var _a;
        (_a = navigationRef.current) === null || _a === void 0 ? void 0 : _a.refresh();
    }, [state === null || state === void 0 ? void 0 : state.boundary.width, state === null || state === void 0 ? void 0 : state.boundary.height]);
    return (React__default["default"].createElement("div", { className: cn__default["default"]('rmc-cropper-wrapper', navigation && 'rmc-cropper-wrapper--with-navigation', className) },
        React__default["default"].createElement(reactAdvancedCropper.CropperFade, { className: 'rmc-cropper-wrapper__fade', visible: loaded },
            children,
            navigation && (React__default["default"].createElement(Navigation, { ref: navigationRef, value: rotate, onRotate: cropper.rotateImage, onRotateEnd: cropper.transformImageEnd, onFlip: cropper.flipImage, className: cn__default["default"]('rmc-cropper-wrapper__navigation', navigationProps.className), buttonClassName: navigationProps.buttonClassName, barClassName: navigationProps.barClassName, valueBarClassName: navigationProps.valueBarClassName, zeroBarClassName: navigationProps.zeroBarClassName, highlightedBarClassName: navigationProps.highlightedBarClassName, disabled: transitions.active }))),
        React__default["default"].createElement(Spinner, { className: cn__default["default"]('rmc-cropper-wrapper__spinner', loading && 'rmc-cropper-wrapper__spinner--visible', spinnerClassName) })));
};

var Cropper = React.forwardRef(function (props, ref) {
    var className = props.className, spinnerClassName = props.spinnerClassName, _a = props.navigation, navigation = _a === void 0 ? true : _a, _b = props.stencilProps, stencilProps = _b === void 0 ? {} : _b, _c = props.navigationProps, navigationProps = _c === void 0 ? {} : _c, wrapperComponent = props.wrapperComponent, _d = props.imageRestriction, imageRestriction = _d === void 0 ? reactAdvancedCropper.ImageRestriction.stencil : _d, cropperProps = tslib.__rest(props, ["className", "spinnerClassName", "navigation", "stencilProps", "navigationProps", "wrapperComponent", "imageRestriction"]);
    var cropperRef = React.useRef(null);
    var WrapperComponent = wrapperComponent || CropperWrapper;
    return (React__default["default"].createElement(reactAdvancedCropper.Cropper, tslib.__assign({}, cropperProps, { ref: reactAdvancedCropper.mergeRefs([ref, cropperRef]), stencilConstraints: stencilConstraints, stencilProps: tslib.__assign(tslib.__assign({ grid: true }, stencilProps), { movable: false }), wrapperComponent: WrapperComponent, wrapperProps: {
            navigationProps: navigationProps,
            navigation: navigation,
            spinnerClassName: spinnerClassName,
        }, imageRestriction: reactAdvancedCropper.ImageRestriction.none, className: cn__default["default"]('rmc-cropper', className), defaultSize: defaultSize, transformImageAlgorithm: transformImage, transitions: true, postProcess: imageRestriction === reactAdvancedCropper.ImageRestriction.none ? zoomStencil : [fitStencilToImage, zoomStencil], resizeCoordinatesAlgorithm: imageRestriction === reactAdvancedCropper.ImageRestriction.none ? undefined : resizeCoordinates })));
});
Cropper.displayName = 'Cropper';

Object.defineProperty(exports, 'CircleStencil', {
    enumerable: true,
    get: function () { return reactAdvancedCropper.CircleStencil; }
});
Object.defineProperty(exports, 'RectangleStencil', {
    enumerable: true,
    get: function () { return reactAdvancedCropper.RectangleStencil; }
});
exports.Cropper = Cropper;
exports.Navigation = Navigation;
exports.RotateComponent = RotateComponent;
//# sourceMappingURL=index.cjs.js.map
